
_InitMain:

;Test.c,9 :: 		void InitMain(void) {
;Test.c,10 :: 		TRISIO.B2 = 0;        // Set GP2 (pin 5) as Output
	BCF        TRISIO+0, 2
;Test.c,11 :: 		TRISIO.B1 = 0;        // Set GP1 (pin 6) as Output
	BCF        TRISIO+0, 1
;Test.c,12 :: 		TRISIO.B3 = 1;        // Set GP3 (pin 4) as input. Not needed as it's input only?
	BSF        TRISIO+0, 3
;Test.c,13 :: 		TRISIO.B0 = 1;        // Set GP0 (pin 7) as input
	BSF        TRISIO+0, 0
;Test.c,14 :: 		PWM1_Init(500);       // Set 500hZ frequency
	BSF        T2CON+0, 0
	BSF        T2CON+0, 1
	MOVLW      124
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;Test.c,15 :: 		PWM1_set_duty(127);   // set 50% duty cycle
	MOVLW      127
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;Test.c,17 :: 		}
L_end_InitMain:
	RETURN
; end of _InitMain

_main:

;Test.c,20 :: 		void main(void) {
;Test.c,21 :: 		InitMain();
	CALL       _InitMain+0
;Test.c,22 :: 		times = 1; // Variable how many times button pressed
	MOVLW      1
	MOVWF      _times+0
;Test.c,23 :: 		while(1){
L_main0:
;Test.c,24 :: 		if(!Time_button) // When time button is pressed
	BTFSC      GP0_bit+0, 0
	GOTO       L_main2
;Test.c,26 :: 		Delay_ms(50);
	MOVLW      65
	MOVWF      R12+0
	MOVLW      238
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
	NOP
;Test.c,27 :: 		while(!Time_button){ // Wait for the button to release
L_main4:
	BTFSC      GP0_bit+0, 0
	GOTO       L_main5
;Test.c,28 :: 		};
	GOTO       L_main4
L_main5:
;Test.c,29 :: 		if (times > 11) times = 1; // Maximum time for pulsing is 55seconds
	MOVLW      128
	XORLW      11
	MOVWF      R0+0
	MOVLW      128
	XORWF      _times+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main6
	MOVLW      1
	MOVWF      _times+0
L_main6:
;Test.c,30 :: 		for(i=0 ; i<times ; i++){ // Tell how many seconds * 5 it will pulse by blinking led
	CLRF       _i+0
L_main7:
	MOVLW      128
	XORWF      _i+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORWF      _times+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main8
;Test.c,31 :: 		TimerLed = 1;
	BSF        GP1_bit+0, 1
;Test.c,32 :: 		delay_ms(250);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      69
	MOVWF      R12+0
	MOVLW      169
	MOVWF      R13+0
L_main10:
	DECFSZ     R13+0, 1
	GOTO       L_main10
	DECFSZ     R12+0, 1
	GOTO       L_main10
	DECFSZ     R11+0, 1
	GOTO       L_main10
	NOP
	NOP
;Test.c,33 :: 		TimerLed = 0;
	BCF        GP1_bit+0, 1
;Test.c,34 :: 		delay_ms(250);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      69
	MOVWF      R12+0
	MOVLW      169
	MOVWF      R13+0
L_main11:
	DECFSZ     R13+0, 1
	GOTO       L_main11
	DECFSZ     R12+0, 1
	GOTO       L_main11
	DECFSZ     R11+0, 1
	GOTO       L_main11
	NOP
	NOP
;Test.c,30 :: 		for(i=0 ; i<times ; i++){ // Tell how many seconds * 5 it will pulse by blinking led
	INCF       _i+0, 1
;Test.c,35 :: 		}
	GOTO       L_main7
L_main8:
;Test.c,36 :: 		times++;
	INCF       _times+0, 1
;Test.c,37 :: 		}
L_main2:
;Test.c,39 :: 		if(!Start_button)  // When start button is pressed
	BTFSC      GP3_bit+0, 3
	GOTO       L_main12
;Test.c,41 :: 		Delay_ms(50);
	MOVLW      65
	MOVWF      R12+0
	MOVLW      238
	MOVWF      R13+0
L_main13:
	DECFSZ     R13+0, 1
	GOTO       L_main13
	DECFSZ     R12+0, 1
	GOTO       L_main13
	NOP
;Test.c,42 :: 		while(!Start_button){ // Wait for the button to release
L_main14:
	BTFSC      GP3_bit+0, 3
	GOTO       L_main15
;Test.c,43 :: 		};
	GOTO       L_main14
L_main15:
;Test.c,44 :: 		milliseconds = 5*times*1000;  // Convert time to milliseconds
	MOVLW      5
	MOVWF      R0+0
	MOVF       _times+0, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_S+0
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	MOVWF      _milliseconds+0
	MOVF       R0+1, 0
	MOVWF      _milliseconds+1
	MOVLW      0
	BTFSC      _milliseconds+1, 7
	MOVLW      255
	MOVWF      _milliseconds+2
	MOVWF      _milliseconds+3
;Test.c,45 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;Test.c,46 :: 		Vdelay_ms(milliseconds);  // Pulse Output for given time
	MOVF       _milliseconds+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       _milliseconds+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;Test.c,47 :: 		PWM1_Stop();
	CALL       _PWM1_Stop+0
;Test.c,48 :: 		}
L_main12:
;Test.c,49 :: 		delay_ms(10);  // Delay 10ms until next round
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main16:
	DECFSZ     R13+0, 1
	GOTO       L_main16
	DECFSZ     R12+0, 1
	GOTO       L_main16
	NOP
	NOP
;Test.c,50 :: 		}
	GOTO       L_main0
;Test.c,51 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
