        sbit Time_button at GP0_bit;
        sbit Start_button at GP3_bit;
        sbit Output at GP2_bit;
        sbit TimerLed at GP1_bit;
        short times;
        short i;
        long milliseconds;

void InitMain(void) {
     TRISIO.B2 = 0;        // Set GP2 (pin 5) as Output
     TRISIO.B1 = 0;        // Set GP1 (pin 6) as Output
     TRISIO.B3 = 1;        // Set GP3 (pin 4) as input. Not needed as it's input only?
     TRISIO.B0 = 1;        // Set GP0 (pin 7) as input
     PWM1_Init(500);       // Set 500hZ frequency
     PWM1_set_duty(127);   // set 50% duty cycle

}


void main(void) {
     InitMain();
     times = 1; // Variable how many times button pressed
     while(1){
              if(!Time_button) // When time button is pressed
              {
				Delay_ms(50);
				while(!Time_button){ // Wait for the button to release
				};
               if (times > 11) times = 1; // Maximum time for pulsing is 55seconds
               for(i=0 ; i<times ; i++){ // Tell how many seconds * 5 it will pulse by blinking led
                  TimerLed = 1;
                  delay_ms(250);
                  TimerLed = 0;
                  delay_ms(250);
               }
                 times++;
              }

              if(!Start_button)  // When start button is pressed
              {
				Delay_ms(50);
				while(!Start_button){ // Wait for the button to release
				};
                 milliseconds = 5*times*1000;  // Convert time to milliseconds
                 PWM1_Start();
                 Vdelay_ms(milliseconds);  // Pulse Output for given time
                 PWM1_Stop();
              }
        delay_ms(10);  // Delay 10ms until next round
     }
}